---
title: WebGLRenderingContext.pixelStorei()
slug: Web/API/WebGLRenderingContext/pixelStorei
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.pixelStorei()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> specifies the pixel storage modes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.pixelStorei(<var>pname</var>, <var>param</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>pname</dt>
 <dd>A {{domxref("Glenum")}} specifying which parameter to set. See below for possible values.</dd>
 <dt>param</dt>
 <dd>A {{domxref("GLint")}} specifying a value to set the <em><code>pname</code></em> parameter to. See below for possible values.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Pixel_storage_parameters">Pixel storage parameters</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Parameter name (for <code>pname</code>)</th>
   <th scope="col">Description</th>
   <th scope="col">Type</th>
   <th scope="col">Default value</th>
   <th scope="col">Allowed values (for <code>param</code>)</th>
   <th scope="col">Specified in</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>gl.PACK_ALIGNMENT</code></td>
   <td>Packing of pixel data into memory</td>
   <td>{{domxref("GLint")}}</td>
   <td>4</td>
   <td>1, 2, 4, 8</td>
   <td>OpenGL ES 2.0</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_ALIGNMENT</code></td>
   <td>Unpacking of pixel data from memory.</td>
   <td>{{domxref("GLint")}}</td>
   <td>4</td>
   <td>1, 2, 4, 8</td>
   <td>OpenGL ES 2.0</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_FLIP_Y_WEBGL</code></td>
   <td>Flips the source data along its vertical axis if true.</td>
   <td>{{domxref("GLboolean")}}</td>
   <td>false</td>
   <td>true, false</td>
   <td>WebGL</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL</code></td>
   <td>Multiplies the alpha channel into the other color channels</td>
   <td>{{domxref("GLboolean")}}</td>
   <td>false</td>
   <td>true, false</td>
   <td>WebGL</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_COLORSPACE_CONVERSION_WEBGL</code></td>
   <td>Default color space conversion or no color space conversion.</td>
   <td>{{domxref("GLenum")}}</td>
   <td><code>gl.BROWSER_DEFAULT_WEBGL</code></td>
   <td><code>gl.BROWSER_DEFAULT_WEBGL</code>, <code>gl.NONE</code></td>
   <td>WebGL</td>
  </tr>
 </tbody>
</table>

<p>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Constant</th>
   <th scope="col">Description</th>
   <th scope="col">Type</th>
   <th scope="col">Default value</th>
   <th scope="col">Allowed values (for <code>param</code>)</th>
   <th scope="col">Specified in</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>gl.PACK_ROW_LENGTH</code></td>
   <td>Number of pixels in a row.</td>
   <td>{{domxref("GLint")}}</td>
   <td>0</td>
   <td>0 to <code>Infinity</code></td>
   <td>OpenGL ES 3.0</td>
  </tr>
  <tr>
   <td><code>gl.PACK_SKIP_PIXELS</code></td>
   <td>Number of pixel locations skipped before the first pixel is written into memory.</td>
   <td>{{domxref("GLint")}}</td>
   <td>0</td>
   <td>0 to <code>Infinity</code></td>
   <td>OpenGL ES 3.0</td>
  </tr>
  <tr>
   <td><code>gl.PACK_SKIP_ROWS</code></td>
   <td>Number of rows of pixel locations skipped before the first pixel is written into memory</td>
   <td>{{domxref("GLint")}}</td>
   <td>0</td>
   <td>0 to <code>Infinity</code></td>
   <td>OpenGL ES 3.0</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_ROW_LENGTH</code></td>
   <td>Number of pixels in a row.</td>
   <td>{{domxref("GLint")}}</td>
   <td>0</td>
   <td>0 to <code>Infinity</code></td>
   <td>OpenGL ES 3.0</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_IMAGE_HEIGHT</code></td>
   <td>Image height used for reading pixel data from memory</td>
   <td>{{domxref("GLint")}}</td>
   <td>0</td>
   <td>0 to <code>Infinity</code></td>
   <td>OpenGL ES 3.0</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_SKIP_PIXELS</code></td>
   <td>Number of pixel images skipped before the first pixel is read from memory</td>
   <td>{{domxref("GLint")}}</td>
   <td>0</td>
   <td>0 to <code>Infinity</code></td>
   <td>OpenGL ES 3.0</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_SKIP_ROWS</code></td>
   <td>Number of rows of pixel locations skipped before the first pixel is read from memory</td>
   <td>{{domxref("GLint")}}</td>
   <td>0</td>
   <td>0 to <code>Infinity</code></td>
   <td>OpenGL ES 3.0</td>
  </tr>
  <tr>
   <td><code>gl.UNPACK_SKIP_IMAGES</code></td>
   <td>Number of pixel images skipped before the first pixel is read from memory</td>
   <td>{{domxref("GLint")}}</td>
   <td>0</td>
   <td>0 to <code>Infinity</code></td>
   <td>OpenGL ES 3.0</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>Setting the pixel storage mode affects the {{domxref("WebGLRenderingContext.readPixels()")}} operations, as well as unpacking of textures with the {{domxref("WebGLRenderingContext.texImage2D()")}} and {{domxref("WebGLRenderingContext.texSubImage2D()")}} methods.<br>
  </p>

<pre class="brush: js">var tex = gl.createTexture();
gl.bindTexture(gl.TEXTURE_2D, tex);
gl.pixelStorei(gl.PACK_ALIGNMENT, 4);
</pre>

<p>To check the values for packing and unpacking of pixel data, you can query the same pixel storage parameters with {{domxref("WebGLRenderingContext.getParameter()")}}.</p>

<pre class="brush: js">gl.getParameter(gl.PACK_ALIGNMENT);
gl.getParameter(gl.UNPACK_ALIGNMENT);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.3", "pixelStorei")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#PIXEL_STORAGE_PARAMETERS", "Pixel Storage Parameters")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Additional pixel storage parameters that aren't specified in OpenGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glPixelStorei.xml", "glPixelStorei")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL ES 2.0 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.2", "pixelStorei")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Updated definition for WebGL 2.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glPixelStorei.xhtml", "glPixelStorei")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the OpenGL ES 3.0 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.pixelStorei")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.readPixels()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texSubImage2D()")}}</li>
</ul>
